/*
 *  ngtk/c/ngtk_omnibox.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

void ngtk_omnibox(int height, int width, int top, int left, int cpair,
				  int attr, char *title, int nlines, char *msg[nlines])
{
    int i;
	int buf = 0;
	ngtk_win_t *box;

    for (i=0;i<=nlines-1;i++)
        if (strlen(msg[i]) >= buf)
			buf = strlen(msg[i]);

	if (height <= nlines + 2)
		height = nlines + 2;
	if (width <= buf + 2)
		width = buf + 2;

    box = ngtk_mkbox(height, width, top, left, cpair, attr, title, 0, 1, 0);
    for (i=0;i<=nlines-1;i++)
        mvwprintw(box->win, i+2, (width/2)-(strlen(msg[i])/2), "%s", msg[i]);

	wrefresh(box->win);

	ngtk_get_keysym();

    ngtk_pop_win(box);
}

void ngtk_auto_pos_omnibox(int height, int width, int cpair, int attr,
						   char *title, int nlines, char *msg[nlines])
{
	int i;
	int buf = 0;
	int top;
	int left;

    for (i=0;i<=nlines-1;i++)
        if (strlen(msg[i]) >= buf)
			buf = strlen(msg[i]);

	if (height <= nlines + 2)
		height = nlines + 2;
	if (width <= buf + 2)
		width = buf + 2;

    top = (LINES/2) - (height/2);
	left = (COLS/2) - (width/2);
	ngtk_omnibox(height, width, top, left, cpair, attr, title, nlines, msg);
}

void ngtk_auto_size_omnibox(int top, int left, int cpair, int attr,
							char *title, int nlines, char *msg[nlines])
{
	int height = nlines + 4;
	int width;
	int i;
	int buf = 0;

	for (i=0;i<=nlines-1;i++)
        if (strlen(msg[i]) > buf)
            buf = strlen(msg[i]);
    width = buf + 4;

	ngtk_omnibox(height, width, top, left, cpair, attr, title, nlines, msg);
}

void ngtk_auto_omnibox(int cpair, int attr, char *title, int nlines,
					   char *msg[nlines])
{
    int height = nlines + 4;
    int width;
    int top = (LINES/2) - (height/2);
    int left;
    int i;
    int buf = 0;

    for (i=0;i<=nlines-1;i++)
        if (strlen(msg[i]) > buf)
            buf = strlen(msg[i]);
    width = buf + 4;
    left = (COLS/2) - (width/2);

	ngtk_omnibox(height, width, top, left, cpair, attr, title, nlines, msg);
}
